Package org.eclipse.swt.custom

## Class CCombo

- java.lang.Object
- - org.eclipse.swt.widgets.Widget
  - - org.eclipse.swt.widgets.Control
    - - org.eclipse.swt.widgets.Scrollable
      - - org.eclipse.swt.widgets.Composite
        - - org.eclipse.swt.custom.CCombo

All Implemented Interfaces:
  `Drawable`

    public class CCombo
    extends Composite

The CCombo class represents a selectable user interface object that combines a text field and a list and issues notification when an item is selected from the list.

CCombo was written to work around certain limitations in the native combo box. Specifically, on win32, the height of a CCombo can be set; attempts to set the height of a Combo are ignored. CCombo can be used anywhere that having the increased flexibility is more important than getting native L&F, but the decision should not be taken lightly. There is no strict requirement that CCombo look or behave the same as the native combo box.

Note that although this class is a subclass of `Composite`, it does not make sense to add children to it, or set a layout on it.

Styles:
  BORDER, READ_ONLY, FLAT, LEAD, LEFT, CENTER, TRAIL, RIGHT
Events:
  DefaultSelection, Modify, Selection, Verify

See Also:
  CCombo snippets, SWT Example: CustomControlExample, Sample code and further information

### Field Summary

### Fields inherited from class org.eclipse.swt.widgets.Control

`handle`

### Constructor Summary

Constructors
`CCombo​(Composite parent, int style)` Constructs a new instance of this class given its parent and a style value describing its behavior and appearance.

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `add​(String string)` Adds the argument to the end of the receiver's list.
`void` `add​(String string, int index)` Adds the argument to the receiver's list at the given zero-relative index.
`void` `addModifyListener​(ModifyListener listener)` Adds the listener to the collection of listeners who will be notified when the receiver's text is modified, by sending it one of the messages defined in the `ModifyListener` interface.
`void` `addSelectionListener​(SelectionListener listener)` Adds the listener to the collection of listeners who will be notified when the user changes the receiver's selection, by sending it one of the messages defined in the `SelectionListener` interface.
`void` `addVerifyListener​(VerifyListener listener)` Adds the listener to the collection of listeners who will be notified when the receiver's text is verified, by sending it one of the messages defined in the `VerifyListener` interface.
`protected void` `checkSubclass()` Checks that this class can be subclassed.
`void` `clearSelection()` Sets the selection in the receiver's text field to an empty selection starting just before the first character.
`Point` `computeSize​(int wHint, int hHint, boolean changed)` Returns the preferred size (in points) of the receiver.
`void` `copy()` Copies the selected text.
`void` `cut()` Cuts the selected text.
`void` `deselect​(int index)` Deselects the item at the given zero-relative index in the receiver's list.
`void` `deselectAll()` Deselects all selected items in the receiver's list.
`int` `getAlignment()` Returns the horizontal alignment.
`Control[]` `getChildren()` Returns a (possibly empty) array containing the receiver's children.
`boolean` `getEditable()` Gets the editable state.
`String` `getItem​(int index)` Returns the item at the given, zero-relative index in the receiver's list.
`int` `getItemCount()` Returns the number of items contained in the receiver's list.
`int` `getItemHeight()` Returns the height of the area which would be used to display one of the items in the receiver's list.
`String[]` `getItems()` Returns an array of `String`s which are the items in the receiver's list.
`boolean` `getListVisible()` Returns `true` if the receiver's list is visible, and `false` otherwise.
`Menu` `getMenu()` Returns the receiver's pop up menu if it has one, or null if it does not.
`Point` `getSelection()` Returns a `Point` whose x coordinate is the start of the selection in the receiver's text field, and whose y coordinate is the end of the selection.
`int` `getSelectionIndex()` Returns the zero-relative index of the item which is currently selected in the receiver's list, or -1 if no item is selected.
`Shell` `getShell()` Returns the receiver's shell.
`int` `getStyle()` Returns the receiver's style information.
`String` `getText()` Returns a string containing a copy of the contents of the receiver's text field.
`int` `getTextHeight()` Returns the height of the receivers's text field.
`int` `getTextLimit()` Returns the maximum number of characters that the receiver's text field is capable of holding.
`int` `getVisibleItemCount()` Gets the number of items that are visible in the drop down portion of the receiver's list.
`int` `indexOf​(String string)` Searches the receiver's list starting at the first item (index 0) until an item is found that is equal to the argument, and returns the index of that item.
`int` `indexOf​(String string, int start)` Searches the receiver's list starting at the given, zero-relative index until an item is found that is equal to the argument, and returns the index of that item.
`boolean` `isFocusControl()` Returns `true` if the receiver has the user-interface focus, and `false` otherwise.
`void` `paste()` Pastes text from clipboard.
`void` `redraw()` Causes the entire bounds of the receiver to be marked as needing to be redrawn.
`void` `redraw​(int x, int y, int width, int height, boolean all)` Causes the rectangular area of the receiver specified by the arguments to be marked as needing to be redrawn.
`void` `remove​(int index)` Removes the item from the receiver's list at the given zero-relative index.
`void` `remove​(int start, int end)` Removes the items from the receiver's list which are between the given zero-relative start and end indices (inclusive).
`void` `remove​(String string)` Searches the receiver's list starting at the first item until an item is found that is equal to the argument, and removes that item from the list.
`void` `removeAll()` Removes all of the items from the receiver's list and clear the contents of receiver's text field.
`void` `removeModifyListener​(ModifyListener listener)` Removes the listener from the collection of listeners who will be notified when the receiver's text is modified.
`void` `removeSelectionListener​(SelectionListener listener)` Removes the listener from the collection of listeners who will be notified when the user changes the receiver's selection.
`void` `removeVerifyListener​(VerifyListener listener)` Removes the listener from the collection of listeners who will be notified when the control is verified.
`void` `select​(int index)` Selects the item at the given zero-relative index in the receiver's list.
`void` `setAlignment​(int align)` Set the horizontal alignment of the CCombo.
`void` `setBackground​(Color color)` Sets the receiver's background color to the color specified by the argument, or to the default system color for the control if the argument is null.
`void` `setEditable​(boolean editable)` Sets the editable state.
`void` `setEnabled​(boolean enabled)` Enables the receiver if the argument is `true`, and disables it otherwise.
`boolean` `setFocus()` Causes the receiver to have the keyboard focus, such that all keyboard events will be delivered to it.
`void` `setFont​(Font font)` Sets the font that the receiver will use to paint textual information to the font specified by the argument, or to the default font for that kind of control if the argument is null.
`void` `setForeground​(Color color)` Sets the receiver's foreground color to the color specified by the argument, or to the default system color for the control if the argument is null.
`void` `setItem​(int index, String string)` Sets the text of the item in the receiver's list at the given zero-relative index to the string argument.
`void` `setItems​(String[] items)` Sets the receiver's list to be the given array of items.
`void` `setLayout​(Layout layout)` Sets the layout which is associated with the receiver to be the argument which may be null.
`void` `setListVisible​(boolean visible)` Marks the receiver's list as visible if the argument is `true`, and marks it invisible otherwise.
`void` `setMenu​(Menu menu)` Sets the receiver's pop up menu to the argument.
`void` `setSelection​(Point selection)` Sets the selection in the receiver's text field to the range specified by the argument whose x coordinate is the start of the selection and whose y coordinate is the end of the selection.
`void` `setText​(String string)` Sets the contents of the receiver's text field to the given string.
`void` `setTextLimit​(int limit)` Sets the maximum number of characters that the receiver's text field is capable of holding to be the argument.
`void` `setToolTipText​(String string)` Sets the receiver's tool tip text to the argument, which may be null indicating that the default tool tip for the control will be shown.
`void` `setVisible​(boolean visible)` Marks the receiver as visible if the argument is `true`, and marks it invisible otherwise.
`void` `setVisibleItemCount​(int count)` Sets the number of items that are visible in the drop down portion of the receiver's list.
`boolean` `traverse​(int event)` Based on the argument, perform one of the expected platform traversal action.

### Methods inherited from class org.eclipse.swt.widgets.Composite

`changed, drawBackground, getBackgroundMode, getLayout, getLayoutDeferred, getTabList, isLayoutDeferred, layout, layout, layout, layout, layout, setBackgroundMode, setLayoutDeferred, setTabList, toString`

### Methods inherited from class org.eclipse.swt.widgets.Scrollable

`computeTrim, getClientArea, getHorizontalBar, getScrollbarsMode, getVerticalBar`

### Methods inherited from class org.eclipse.swt.widgets.Control

`addControlListener, addDragDetectListener, addFocusListener, addGestureListener, addHelpListener, addKeyListener, addMenuDetectListener, addMouseListener, addMouseMoveListener, addMouseTrackListener, addMouseWheelListener, addPaintListener, addTouchListener, addTraverseListener, computeSize, dragDetect, dragDetect, forceFocus, getAccessible, getBackground, getBackgroundImage, getBorderWidth, getBounds, getCursor, getDragDetect, getEnabled, getFont, getForeground, getLayoutData, getLocation, getMonitor, getOrientation, getParent, getRegion, getSize, getTextDirection, getToolTipText, getTouchEnabled, getVisible, internal_dispose_GC, internal_new_GC, isEnabled, isReparentable, isVisible, moveAbove, moveBelow, pack, pack, print, removeControlListener, removeDragDetectListener, removeFocusListener, removeGestureListener, removeHelpListener, removeKeyListener, removeMenuDetectListener, removeMouseListener, removeMouseMoveListener, removeMouseTrackListener, removeMouseWheelListener, removePaintListener, removeTouchListener, removeTraverseListener, requestLayout, setBackgroundImage, setBounds, setBounds, setCapture, setCursor, setDragDetect, setLayoutData, setLocation, setLocation, setOrientation, setParent, setRedraw, setRegion, setSize, setSize, setTextDirection, setTouchEnabled, toControl, toControl, toDisplay, toDisplay, traverse, traverse, update`

### Methods inherited from class org.eclipse.swt.widgets.Widget

`addDisposeListener, addListener, checkWidget, dispose, getData, getData, getDisplay, getListeners, isAutoDirection, isDisposed, isListening, notifyListeners, removeDisposeListener, removeListener, removeListener, reskin, setData, setData`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.eclipse.swt.graphics.Drawable

`isAutoScalable`

### Constructor Detail

#### CCombo

    public CCombo​(Composite parent,
                  int style)

Constructs a new instance of this class given its parent and a style value describing its behavior and appearance.

The style value is either one of the style constants defined in class `SWT` which is applicable to instances of this class, or must be built by bitwise OR'ing together (that is, using the `int` "|" operator) two or more of those `SWT` style constants. The class description lists the style constants that are applicable to the class. Style bits are also inherited from superclasses.

Parameters:
  `parent` - a widget which will be the parent of the new instance (cannot be null)
  `style` - the style of widget to construct
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the parent is null
  `SWTException` -
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the parent
See Also:
  `SWT.BORDER`, `SWT.READ_ONLY`, `SWT.FLAT`, `SWT.LEAD`, `SWT.LEFT`, `SWT.CENTER`, `SWT.RIGHT`, `SWT.TRAIL`, `Widget.getStyle()`

### Method Detail

#### add

    public void add​(String string)

Adds the argument to the end of the receiver's list.

Note: If control characters like '\n', '\t' etc. are used in the string, then the behavior is platform dependent.

Parameters:
  `string` - the new item
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the string is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  `add(String,int)`

#### add

    public void add​(String string,
                    int index)

Adds the argument to the receiver's list at the given zero-relative index.

Note: To add an item at the end of the list, use the result of calling `getItemCount()` as the index or use `add(String)`.

Also note, if control characters like '\n', '\t' etc. are used in the string, then the behavior is platform dependent.

Parameters:
  `string` - the new item
  `index` - the index for the item
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the string is null
  - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the list (inclusive)
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  `add(String)`

#### addModifyListener

    public void addModifyListener​(ModifyListener listener)

Adds the listener to the collection of listeners who will be notified when the receiver's text is modified, by sending it one of the messages defined in the `ModifyListener` interface.

Parameters:
  `listener` - the listener which should be notified
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the listener is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  `ModifyListener`, `removeModifyListener(org.eclipse.swt.events.ModifyListener)`

#### addSelectionListener

    public void addSelectionListener​(SelectionListener listener)

Adds the listener to the collection of listeners who will be notified when the user changes the receiver's selection, by sending it one of the messages defined in the `SelectionListener` interface.

`widgetSelected` is called when the combo's list selection changes. `widgetDefaultSelected` is typically called when ENTER is pressed the combo's text area.

Parameters:
  `listener` - the listener which should be notified when the user changes the receiver's selection
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the listener is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  `SelectionListener`, `removeSelectionListener(org.eclipse.swt.events.SelectionListener)`, `SelectionEvent`

#### addVerifyListener

    public void addVerifyListener​(VerifyListener listener)

Adds the listener to the collection of listeners who will be notified when the receiver's text is verified, by sending it one of the messages defined in the `VerifyListener` interface.

Parameters:
  `listener` - the listener which should be notified
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the listener is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.3
See Also:
  `VerifyListener`, `removeVerifyListener(org.eclipse.swt.events.VerifyListener)`

#### checkSubclass

    protected void checkSubclass()

Description copied from class: `Widget`
Checks that this class can be subclassed.

The SWT class library is intended to be subclassed only at specific, controlled points (most notably, `Composite` and `Canvas` when implementing new widgets). This method enforces this rule unless it is overridden.

IMPORTANT: By providing an implementation of this method that allows a subclass of a class which does not normally allow subclassing to be created, the implementer agrees to be fully responsible for the fact that any such subclass will likely fail between SWT releases and will be strongly platform specific. No support is provided for user-written classes which are implemented in this fashion.

The ability to subclass outside of the allowed SWT classes is intended purely to enable those not on the SWT development team to implement patches in order to get around specific limitations in advance of when those limitations can be addressed by the team. Subclassing should not be attempted without an intimate and detailed understanding of the hierarchy.

Overrides:
  `checkSubclass` in class `Composite`

#### clearSelection

    public void clearSelection()

Sets the selection in the receiver's text field to an empty selection starting just before the first character. If the text field is editable, this has the effect of placing the i-beam at the start of the text.

Note: To clear the selected items in the receiver's list, use `deselectAll()`.

Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  `deselectAll()`

#### computeSize

    public Point computeSize​(int wHint,
                             int hHint,
                             boolean changed)

Description copied from class: `Control`
Returns the preferred size (in points) of the receiver.

The preferred size of a control is the size that it would best be displayed at. The width hint and height hint arguments allow the caller to ask a control questions such as "Given a particular width, how high does the control need to be to show all of the contents?" To indicate that the caller does not wish to constrain a particular dimension, the constant `SWT.DEFAULT` is passed for the hint.

If the changed flag is `true`, it indicates that the receiver's contents have changed, therefore any caches that a layout manager containing the control may have been keeping need to be flushed. When the control is resized, the changed flag will be `false`, so layout manager caches can be retained.

Overrides:
  `computeSize` in class `Control`
Parameters:
  `wHint` - the width hint (can be `SWT.DEFAULT`)
  `hHint` - the height hint (can be `SWT.DEFAULT`)
  `changed` - `true` if the control's contents have changed, and `false` otherwise
Returns:
  the preferred size of the control.
See Also:
  `Layout`, `Control.getBorderWidth()`, `Control.getBounds()`, `Control.getSize()`, `Control.pack(boolean)`, "computeTrim, getClientArea for controls that implement them"

#### copy

    public void copy()

Copies the selected text.

The current selection is copied to the clipboard.

Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.3

#### cut

    public void cut()

Cuts the selected text.

The current selection is first copied to the clipboard and then deleted from the widget.

Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.3

#### deselect

    public void deselect​(int index)

Deselects the item at the given zero-relative index in the receiver's list. If the item at the index was already deselected, it remains deselected. Indices that are out of range are ignored.

Parameters:
  `index` - the index of the item to deselect
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### deselectAll

    public void deselectAll()

Deselects all selected items in the receiver's list.

Note: To clear the selection in the receiver's text field, use `clearSelection()`.

Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  `clearSelection()`

#### getAlignment

    public int getAlignment()

Returns the horizontal alignment. The alignment style (LEFT, CENTER or RIGHT) is returned.

Returns:
  SWT.LEFT, SWT.RIGHT or SWT.CENTER
Since:
  3.113

#### getChildren

    public Control[] getChildren()

Description copied from class: `Composite`
Returns a (possibly empty) array containing the receiver's children. Children are returned in the order that they are drawn. The topmost control appears at the beginning of the array. Subsequent controls draw beneath this control and appear later in the array.

Note: This is not the actual structure used by the receiver to maintain its list of children, so modifying the array will not affect the receiver.

Overrides:
  `getChildren` in class `Composite`
Returns:
  an array of children
See Also:
  `Control.moveAbove(org.eclipse.swt.widgets.Control)`, `Control.moveBelow(org.eclipse.swt.widgets.Control)`

#### getEditable

    public boolean getEditable()

Gets the editable state.

Returns:
  whether or not the receiver is editable
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.0

#### getItem

    public String getItem​(int index)

Returns the item at the given, zero-relative index in the receiver's list. Throws an exception if the index is out of range.

Parameters:
  `index` - the index of the item to return
Returns:
  the item at the given index
Throws:
  `IllegalArgumentException` -
  - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the list minus 1 (inclusive)
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getItemCount

    public int getItemCount()

Returns the number of items contained in the receiver's list.

Returns:
  the number of items
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getItemHeight

    public int getItemHeight()

Returns the height of the area which would be used to display one of the items in the receiver's list.

Returns:
  the height of one item
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getItems

    public String[] getItems()

Returns an array of `String`s which are the items in the receiver's list.

Note: This is not the actual structure used by the receiver to maintain its list of items, so modifying the array will not affect the receiver.

Returns:
  the items in the receiver's list
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getListVisible

    public boolean getListVisible()

Returns `true` if the receiver's list is visible, and `false` otherwise.

If one of the receiver's ancestors is not visible or some other condition makes the receiver not visible, this method may still indicate that it is considered visible even though it may not actually be showing.

Returns:
  the receiver's list's visibility state
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.4

#### getMenu

    public Menu getMenu()

Description copied from class: `Control`
Returns the receiver's pop up menu if it has one, or null if it does not. All controls may optionally have a pop up menu that is displayed when the user requests one for the control. The sequence of key strokes, button presses and/or button releases that are used to request a pop up menu is platform specific.

Overrides:
  `getMenu` in class `Control`
Returns:
  the receiver's menu

#### getSelection

    public Point getSelection()

Returns a `Point` whose x coordinate is the start of the selection in the receiver's text field, and whose y coordinate is the end of the selection. The returned values are zero-relative. An "empty" selection as indicated by the the x and y coordinates having the same value.

Returns:
  a point representing the selection start and end
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getSelectionIndex

    public int getSelectionIndex()

Returns the zero-relative index of the item which is currently selected in the receiver's list, or -1 if no item is selected.

Returns:
  the index of the selected item
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getShell

    public Shell getShell()

Description copied from class: `Control`
Returns the receiver's shell. For all controls other than shells, this simply returns the control's nearest ancestor shell. Shells return themselves, even if they are children of other shells.

Overrides:
  `getShell` in class `Control`
Returns:
  the receiver's shell
See Also:
  `Control.getParent()`

#### getStyle

    public int getStyle()

Description copied from class: `Widget`
Returns the receiver's style information.

Note that the value which is returned by this method may not match the value which was provided to the constructor when the receiver was created. This can occur when the underlying operating system does not support a particular combination of requested styles. For example, if the platform widget used to implement a particular SWT widget always has scroll bars, the result of calling this method would always have the `SWT.H_SCROLL` and `SWT.V_SCROLL` bits set.

Overrides:
  `getStyle` in class `Widget`
Returns:
  the style bits

#### getText

    public String getText()

Returns a string containing a copy of the contents of the receiver's text field.

Returns:
  the receiver's text
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getTextHeight

    public int getTextHeight()

Returns the height of the receivers's text field.

Returns:
  the text height
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getTextLimit

    public int getTextLimit()

Returns the maximum number of characters that the receiver's text field is capable of holding. If this has not been changed by `setTextLimit()`, it will be the constant `Combo.LIMIT`.

Returns:
  the text limit
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### getVisibleItemCount

    public int getVisibleItemCount()

Gets the number of items that are visible in the drop down portion of the receiver's list.

Returns:
  the number of items that are visible
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.0

#### indexOf

    public int indexOf​(String string)

Searches the receiver's list starting at the first item (index 0) until an item is found that is equal to the argument, and returns the index of that item. If no item is found, returns -1.

Parameters:
  `string` - the search item
Returns:
  the index of the item
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the string is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### indexOf

    public int indexOf​(String string,
                       int start)

Searches the receiver's list starting at the given, zero-relative index until an item is found that is equal to the argument, and returns the index of that item. If no item is found or the starting index is out of range, returns -1.

Parameters:
  `string` - the search item
  `start` - the zero-relative index at which to begin the search
Returns:
  the index of the item
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the string is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### isFocusControl

    public boolean isFocusControl()

Description copied from class: `Control`
Returns `true` if the receiver has the user-interface focus, and `false` otherwise.

Overrides:
  `isFocusControl` in class `Control`
Returns:
  the receiver's focus state

#### paste

    public void paste()

Pastes text from clipboard.

The selected text is deleted from the widget and new text inserted from the clipboard.

Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.3

#### redraw

    public void redraw()

Description copied from class: `Control`
Causes the entire bounds of the receiver to be marked as needing to be redrawn. The next time a paint request is processed, the control will be completely painted, including the background.

Schedules a paint request if the invalidated area is visible or becomes visible later. It is not necessary for the caller to explicitly call `Control.update()` after calling this method, but depending on the platform, the automatic repaints may be delayed considerably.

Overrides:
  `redraw` in class `Control`
See Also:
  `Control.update()`, `PaintListener`, `SWT.Paint`, `SWT.NO_BACKGROUND`, `SWT.NO_REDRAW_RESIZE`, `SWT.NO_MERGE_PAINTS`, `SWT.DOUBLE_BUFFERED`

#### redraw

    public void redraw​(int x,
                       int y,
                       int width,
                       int height,
                       boolean all)

Description copied from class: `Control`
Causes the rectangular area of the receiver specified by the arguments to be marked as needing to be redrawn. The next time a paint request is processed, that area of the receiver will be painted, including the background. If the `all` flag is `true`, any children of the receiver which intersect with the specified area will also paint their intersecting areas. If the `all` flag is `false`, the children will not be painted.

Schedules a paint request if the invalidated area is visible or becomes visible later. It is not necessary for the caller to explicitly call `Control.update()` after calling this method, but depending on the platform, the automatic repaints may be delayed considerably.

Overrides:
  `redraw` in class `Control`
Parameters:
  `x` - the x coordinate of the area to draw
  `y` - the y coordinate of the area to draw
  `width` - the width of the area to draw
  `height` - the height of the area to draw
  `all` - `true` if children should redraw, and `false` otherwise
See Also:
  `Control.update()`, `PaintListener`, `SWT.Paint`, `SWT.NO_BACKGROUND`, `SWT.NO_REDRAW_RESIZE`, `SWT.NO_MERGE_PAINTS`, `SWT.DOUBLE_BUFFERED`

#### remove

    public void remove​(int index)

Removes the item from the receiver's list at the given zero-relative index.

Parameters:
  `index` - the index for the item
Throws:
  `IllegalArgumentException` -
  - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the list minus 1 (inclusive)
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### remove

    public void remove​(int start,
                       int end)

Removes the items from the receiver's list which are between the given zero-relative start and end indices (inclusive).

Parameters:
  `start` - the start of the range
  `end` - the end of the range
Throws:
  `IllegalArgumentException` -
  - ERROR_INVALID_RANGE - if either the start or end are not between 0 and the number of elements in the list minus 1 (inclusive)
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### remove

    public void remove​(String string)

Searches the receiver's list starting at the first item until an item is found that is equal to the argument, and removes that item from the list.

Parameters:
  `string` - the item to remove
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the string is null
  - ERROR_INVALID_ARGUMENT - if the string is not found in the list
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### removeAll

    public void removeAll()

Removes all of the items from the receiver's list and clear the contents of receiver's text field.

Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### removeModifyListener

    public void removeModifyListener​(ModifyListener listener)

Removes the listener from the collection of listeners who will be notified when the receiver's text is modified.

Parameters:
  `listener` - the listener which should no longer be notified
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the listener is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  `ModifyListener`, `addModifyListener(org.eclipse.swt.events.ModifyListener)`

#### removeSelectionListener

    public void removeSelectionListener​(SelectionListener listener)

Removes the listener from the collection of listeners who will be notified when the user changes the receiver's selection.

Parameters:
  `listener` - the listener which should no longer be notified
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the listener is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
See Also:
  `SelectionListener`, `addSelectionListener(org.eclipse.swt.events.SelectionListener)`

#### removeVerifyListener

    public void removeVerifyListener​(VerifyListener listener)

Removes the listener from the collection of listeners who will be notified when the control is verified.

Parameters:
  `listener` - the listener which should no longer be notified
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the listener is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.3
See Also:
  `VerifyListener`, `addVerifyListener(org.eclipse.swt.events.VerifyListener)`

#### select

    public void select​(int index)

Selects the item at the given zero-relative index in the receiver's list. If the item at the index was already selected, it remains selected. Indices that are out of range are ignored.

Parameters:
  `index` - the index of the item to select
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setAlignment

    public void setAlignment​(int align)

Set the horizontal alignment of the CCombo. Use the values LEFT, CENTER and RIGHT to align image and text within the available space.

Parameters:
  `align` - the alignment style of LEFT, RIGHT or CENTER
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
  - ERROR_INVALID_ARGUMENT - if the value of align is not one of SWT.LEFT, SWT.RIGHT or SWT.CENTER
Since:
  3.113

#### setBackground

    public void setBackground​(Color color)

Description copied from class: `Control`
Sets the receiver's background color to the color specified by the argument, or to the default system color for the control if the argument is null.

Note: This operation is a hint and may be overridden by the platform.

Overrides:
  `setBackground` in class `Control`
Parameters:
  `color` - the new color (or null)

#### setEditable

    public void setEditable​(boolean editable)

Sets the editable state.

Parameters:
  `editable` - the new editable state
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.0

#### setEnabled

    public void setEnabled​(boolean enabled)

Description copied from class: `Control`
Enables the receiver if the argument is `true`, and disables it otherwise. A disabled control is typically not selectable from the user interface and draws with an inactive or "grayed" look.

Overrides:
  `setEnabled` in class `Control`
Parameters:
  `enabled` - the new enabled state

#### setFocus

    public boolean setFocus()

Description copied from class: `Control`
Causes the receiver to have the keyboard focus, such that all keyboard events will be delivered to it. Focus reassignment will respect applicable platform constraints.

Overrides:
  `setFocus` in class `Composite`
Returns:
  `true` if the control got focus, and `false` if it was unable to.
See Also:
  `Control.forceFocus()`

#### setFont

    public void setFont​(Font font)

Description copied from class: `Control`
Sets the font that the receiver will use to paint textual information to the font specified by the argument, or to the default font for that kind of control if the argument is null.

Overrides:
  `setFont` in class `Control`
Parameters:
  `font` - the new font (or null)

#### setForeground

    public void setForeground​(Color color)

Description copied from class: `Control`
Sets the receiver's foreground color to the color specified by the argument, or to the default system color for the control if the argument is null.

Note: This operation is a hint and may be overridden by the platform.

Overrides:
  `setForeground` in class `Control`
Parameters:
  `color` - the new color (or null)

#### setItem

    public void setItem​(int index,
                        String string)

Sets the text of the item in the receiver's list at the given zero-relative index to the string argument. This is equivalent to `remove`'ing the old item at the index, and then `add`'ing the new item at that index.

Parameters:
  `index` - the index for the item
  `string` - the new text for the item
Throws:
  `IllegalArgumentException` -
  - ERROR_INVALID_RANGE - if the index is not between 0 and the number of elements in the list minus 1 (inclusive)
  - ERROR_NULL_ARGUMENT - if the string is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setItems

    public void setItems​(String[] items)

Sets the receiver's list to be the given array of items.

Parameters:
  `items` - the array of items
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the items array is null
  - ERROR_INVALID_ARGUMENT - if an item in the items array is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setLayout

    public void setLayout​(Layout layout)

Sets the layout which is associated with the receiver to be the argument which may be null.

Note: No Layout can be set on this Control because it already manages the size and position of its children.

Overrides:
  `setLayout` in class `Composite`
Parameters:
  `layout` - the receiver's new layout or null
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setListVisible

    public void setListVisible​(boolean visible)

Marks the receiver's list as visible if the argument is `true`, and marks it invisible otherwise.

If one of the receiver's ancestors is not visible or some other condition makes the receiver not visible, marking it visible may not actually cause it to be displayed.

Parameters:
  `visible` - the new visibility state
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.4

#### setMenu

    public void setMenu​(Menu menu)

Description copied from class: `Control`
Sets the receiver's pop up menu to the argument. All controls may optionally have a pop up menu that is displayed when the user requests one for the control. The sequence of key strokes, button presses and/or button releases that are used to request a pop up menu is platform specific.

Note: Disposing of a control that has a pop up menu will dispose of the menu. To avoid this behavior, set the menu to null before the control is disposed.

Overrides:
  `setMenu` in class `Control`
Parameters:
  `menu` - the new pop up menu

#### setSelection

    public void setSelection​(Point selection)

Sets the selection in the receiver's text field to the range specified by the argument whose x coordinate is the start of the selection and whose y coordinate is the end of the selection.

Parameters:
  `selection` - a point representing the new selection start and end
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the point is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setText

    public void setText​(String string)

Sets the contents of the receiver's text field to the given string.

Note: The text field in a `Combo` is typically only capable of displaying a single line of text. Thus, setting the text to a string containing line breaks or other special characters will probably cause it to display incorrectly.

Also note, if control characters like '\n', '\t' etc. are used in the string, then the behavior is platform dependent.

Parameters:
  `string` - the new text
Throws:
  `IllegalArgumentException` -
  - ERROR_NULL_ARGUMENT - if the string is null
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setTextLimit

    public void setTextLimit​(int limit)

Sets the maximum number of characters that the receiver's text field is capable of holding to be the argument.

Parameters:
  `limit` - new text limit
Throws:
  `IllegalArgumentException` -
  - ERROR_CANNOT_BE_ZERO - if the limit is zero
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver

#### setToolTipText

    public void setToolTipText​(String string)

Description copied from class: `Control`
Sets the receiver's tool tip text to the argument, which may be null indicating that the default tool tip for the control will be shown. For a control that has a default tool tip, such as the Tree control on Windows, setting the tool tip text to an empty string replaces the default, causing no tool tip text to be shown.

The mnemonic indicator (character '&') is not displayed in a tool tip. To display a single '&' in the tool tip, the character '&' can be escaped by doubling it in the string.

NOTE: This operation is a hint and behavior is platform specific, on Windows for CJK-style mnemonics of the form " (&C)" at the end of the tooltip text are not shown in tooltip.

Overrides:
  `setToolTipText` in class `Control`
Parameters:
  `string` - the new tool tip text (or null)

#### setVisible

    public void setVisible​(boolean visible)

Description copied from class: `Control`
Marks the receiver as visible if the argument is `true`, and marks it invisible otherwise.

If one of the receiver's ancestors is not visible or some other condition makes the receiver not visible, marking it visible may not actually cause it to be displayed.

Overrides:
  `setVisible` in class `Control`
Parameters:
  `visible` - the new visibility state

#### setVisibleItemCount

    public void setVisibleItemCount​(int count)

Sets the number of items that are visible in the drop down portion of the receiver's list.

Parameters:
  `count` - the new number of items to be visible
Throws:
  `SWTException` -
  - ERROR_WIDGET_DISPOSED - if the receiver has been disposed
  - ERROR_THREAD_INVALID_ACCESS - if not called from the thread that created the receiver
Since:
  3.0

#### traverse

    public boolean traverse​(int event)

Description copied from class: `Control`
Based on the argument, perform one of the expected platform traversal action. The argument should be one of the constants: `SWT.TRAVERSE_ESCAPE`, `SWT.TRAVERSE_RETURN`, `SWT.TRAVERSE_TAB_NEXT`, `SWT.TRAVERSE_TAB_PREVIOUS`, `SWT.TRAVERSE_ARROW_NEXT`, `SWT.TRAVERSE_ARROW_PREVIOUS`, `SWT.TRAVERSE_PAGE_NEXT` and `SWT.TRAVERSE_PAGE_PREVIOUS`.

Overrides:
  `traverse` in class `Control`
Parameters:
  `event` - the type of traversal
Returns:
  true if the traversal succeeded